package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.LoginAccount;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class LoginAccount_Grid_Main{
    private String username;
    private String loginaccountid;
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Timestamp lastlogintime;
    private String loginaccountname;
    private String userid;
    private String language;
    private Integer isenable;
    private String srfmajortext;


    private String srfdataaccaction;


    private String srfkey;


    public  void fromLoginAccount(LoginAccount sourceEntity)  {
         this.setUsername(sourceEntity.getUsername());
         this.setLoginaccountid(sourceEntity.getLoginaccountid());
         this.setLastlogintime(sourceEntity.getLastlogintime());
         this.setLoginaccountname(sourceEntity.getLoginaccountname());
         this.setUserid(sourceEntity.getUserid());
         this.setLanguage(sourceEntity.getLanguage());
         this.setIsenable(sourceEntity.getIsenable());
         this.setSrfmajortext(sourceEntity.getLoginaccountname());
         this.setSrfdataaccaction(sourceEntity.getLoginaccountid());
         this.setSrfkey(sourceEntity.getLoginaccountid());
	}

	public static Page<LoginAccount_Grid_Main> fromLoginAccount(Page<LoginAccount> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<LoginAccount_Grid_Main> targetpage=new Page<LoginAccount_Grid_Main>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<LoginAccount_Grid_Main> records=new ArrayList<LoginAccount_Grid_Main>();
        for(LoginAccount source:sourcePage.getRecords()) {
            LoginAccount_Grid_Main target=new LoginAccount_Grid_Main();
            target.fromLoginAccount(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("username","用户"); }});
        columnModelList.add(new HashMap(){ { put("loginaccountname","登录帐户"); }});
        columnModelList.add(new HashMap(){ { put("isenable","是否启用"); }});
        columnModelList.add(new HashMap(){ { put("language","默认语言"); }});
        columnModelList.add(new HashMap(){ { put("lastlogintime","最后登录时间"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<LoginAccount> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(LoginAccount source:searchResult.getRecords()) {
            LoginAccount_Grid_Main target=new LoginAccount_Grid_Main();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<LoginAccount> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}